#include "TimerOne.h"            // Avaiable from http://www.arduino.cc/playground/Code/Timer1

//(Zero-Cross подключаем на контакт D2)
volatile int i = 0;              // счетчик
volatile boolean zero_cross = 0; // Boolean to store a "switch" to tell us if we have crossed zero
int AC_pin = 3;                  // Контакт ШИМ (PWM)
int buton1 = 4;                  // первая кнопка pin 4
int buton2 = 5;                  // вторая кнопка pin 5
int dim2 = 0;
int dim = 128;                   // Уровень диммирования (0-128)  0 = ВКЛ, 128 = ВЫКЛ
int pas = 8;                     // кол-во шагов изменения интенсивности

int freqStep = 75;    // это пауза-света для частоты электросети 50Гц


void setup() {
  Serial.begin(9600);
  pinMode(buton1, INPUT_PULLUP);  
  pinMode(buton2, INPUT_PULLUP);  
  pinMode(AC_pin, OUTPUT);
  attachInterrupt(0, zero_cross_detect, RISING);    // Прерывание для определения пересечения Нуля (Zero-Cross на контакт D2)
  Timer1.initialize(freqStep);                      
  Timer1.attachInterrupt(dim_check, freqStep);
  delay (1000);
}

void zero_cross_detect() {  //при пересечении Нуля
  zero_cross = true;
  i = 0;
  digitalWrite(AC_pin, LOW);
}

void dim_check() {
  if (zero_cross == true) {  //если Ноль пересекли
    if (i >= dim) {
      digitalWrite(AC_pin, HIGH);  //включаем свет
      i = 0;
      zero_cross = false;  //сбрасываем признак пересечения Нуля
    }
    else {
      i++;  //увеличиваем счетчик времени
    }
  }
}

void loop() {
  if (digitalRead(buton1) == LOW)  {
    if (dim < 127) {
      dim = dim + pas;
      if (dim > 127) {
        dim = 128;
      }
    }
  }
  if (digitalRead(buton2) == LOW)  {
    if (dim > 5) {
      dim = dim - pas;
      if (dim < 0) {
        dim = 0;
      }
    }
  }
  while (digitalRead(buton1) == LOW) {  }
  delay(10);
  while (digitalRead(buton2) == LOW) {  }
  delay(10);

  dim2 = 255 - 2 * dim;
  if (dim2 < 0)  {
    dim2 = 0;
  }

  Serial.print("dim=");
  Serial.print(dim);
  Serial.print("     dim2=");
  Serial.print(dim2);
  Serial.print("     dim1=");
  Serial.print(2 * dim);
  Serial.print('\n');
  delay (100);
}

